﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "LMGrabRange.h"

#include "LMItemDrop.h"
#include "Player/LMPlayer.h"


ULMGrabRange::ULMGrabRange()
{
	PrimaryComponentTick.bCanEverTick = true;

}

void ULMGrabRange::TickComponent(float DeltaTime, enum ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction)
{
	Super::TickComponent(DeltaTime, TickType, ThisTickFunction);

	
}

void ULMGrabRange::OnDropOverlapped_Implementation(ALMItemDrop* ItemDrop)
{
	Drops.AddUnique(ItemDrop);
}


void ULMGrabRange::ConsumeDrop(ALMItemDrop* ItemDrop)
{
	ItemDrop->ConsumePack(Player);
	
}

void ULMGrabRange::BeginPlay()
{
	Super::BeginPlay();
	Player = CastChecked<ALMPlayer>(GetOwner());
	OnComponentBeginOverlap.AddUniqueDynamic(this, &ULMGrabRange::OnComponentOverlap);
}

void ULMGrabRange::OnComponentOverlap(UPrimitiveComponent* OverlappedComponent, AActor* OtherActor,
	UPrimitiveComponent* OtherComp, int32 OtherBodyIndex, bool bFromSweep, const FHitResult& SweepResult)
{
	if (!bIsEnabled)
		return;
	
	if (ALMItemDrop* ItemDrop = Cast<ALMItemDrop>(OtherActor))
	{
		OnDropOverlapped(ItemDrop);
	}
}

